Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/ice.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 8517)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 8518)
@@ -170,7 +170,4 @@
    
    !                                     !!** ice-dynamics namelist (namice_dyn) **
-   LOGICAL,  PUBLIC ::   ln_dynFULL       !:  dyn.: full ice dynamics               (rheology + advection + ridging/rafting + correction)
-   LOGICAL,  PUBLIC ::   ln_dynRHGADV     !:  dyn.: no ridge/raft & no corrections  (rheology + advection)
-   LOGICAL,  PUBLIC ::   ln_dynADV        !:  dyn.: only advection w prescribed vel.(rn_uvice + advection)
    REAL(wp), PUBLIC ::   rn_ishlat        !: lateral boundary condition for sea-ice
    REAL(wp), PUBLIC ::   rn_cio           !: drag coefficient for oceanic stress
@@ -180,22 +177,9 @@
    REAL(wp), PUBLIC ::   rn_lfrelax       !:    relaxation time scale (s-1) to reach static friction (landfast ice) 
    !
-   !                                     !!** ice-rdige/raft namelist (namice_rdgrft) **
-   LOGICAL , PUBLIC ::   ln_str_H79       !: ice strength parameterization (Hibler79)
-   REAL(wp), PUBLIC ::   rn_pstar         !: determines ice strength, Hibler JPO79
-   REAL(wp), PUBLIC ::   rn_crhg          !: determines changes in ice strength
-   LOGICAL , PUBLIC ::   ln_str_R75       !: ice strength parameterization (Rothrock75)
-   REAL(wp), PUBLIC ::   rn_perdg         !: ridging work divided by pot. energy change in ridging
-   !
    !                                     !!** ice-rheology namelist (namice_rhg) **
-   LOGICAL , PUBLIC ::   ln_rhg_EVP       !: EVP rheology
    REAL(wp), PUBLIC ::   rn_creepl        !: creep limit : has to be under 1.0e-9
    REAL(wp), PUBLIC ::   rn_ecc           !: eccentricity of the elliptical yield curve
    INTEGER , PUBLIC ::   nn_nevp          !: number of iterations for subcycling
    REAL(wp), PUBLIC ::   rn_relast        !: ratio => telast/rdt_ice (1/3 or 1/9 depending on nb of subcycling nevp) 
-   !
-   !                                     !!** ice-advection namelist (namice_adv) **
-   LOGICAL , PUBLIC ::   ln_adv_Pra       !: Prather        advection scheme
-   LOGICAL , PUBLIC ::   ln_adv_UMx       !: Ultimate-Macho advection scheme
-   INTEGER , PUBLIC ::   nn_UMx           !: order of the UMx advection scheme   
    !
    !                                     !!** ice-thermodynamics namelist (namice_thd) **
@@ -230,5 +214,4 @@
 
    !                                     !!** ice-salinity namelist (namice_sal) **
-   LOGICAL , PUBLIC ::   ln_icedS         !: activate gravity drainage and flushing (T) or not (F)
    INTEGER , PUBLIC ::   nn_icesal        !: salinity configuration used in the model
    !                                      ! 1 - constant salinity in both space and time
@@ -236,8 +219,4 @@
    !                                      ! 3 - salinity profile, constant in time
    REAL(wp), PUBLIC ::   rn_icesal        !: bulk salinity (ppt) in case of constant salinity
-   REAL(wp), PUBLIC ::   rn_sal_gd        !: restoring salinity for gravity drainage [PSU]
-   REAL(wp), PUBLIC ::   rn_time_gd       !: restoring time constant for gravity drainage (= 20 days) [s]
-   REAL(wp), PUBLIC ::   rn_sal_fl        !: restoring salinity for flushing [PSU]
-   REAL(wp), PUBLIC ::   rn_time_fl       !: restoring time constant for gravity drainage (= 10 days) [s]
    REAL(wp), PUBLIC ::   rn_simax         !: maximum ice salinity [PSU]
    REAL(wp), PUBLIC ::   rn_simin         !: minimum ice salinity [PSU]
@@ -329,5 +308,4 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hfx_dif     !: total heat flux causing Temp change in the ice   [W.m-2]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hfx_snw     !: heat flux for snow melt                          [W.m-2]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hfx_err     !: heat flux error after heat diffusion             [W.m-2]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hfx_err_dif !: heat flux remaining due to change in non-solar flux [W.m-2]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hfx_err_rem !: heat flux error after heat remapping             [W.m-2]
@@ -494,5 +472,5 @@
          &      sfx_res(jpi,jpj) , sfx_bri(jpi,jpj) , sfx_dyn(jpi,jpj) , sfx_sub(jpi,jpj) , sfx_lam(jpi,jpj) ,  &
          &      sfx_bog(jpi,jpj) , sfx_bom(jpi,jpj) , sfx_sum(jpi,jpj) , sfx_sni(jpi,jpj) , sfx_opw(jpi,jpj) ,  &
-         &      hfx_res(jpi,jpj) , hfx_snw(jpi,jpj) , hfx_sub(jpi,jpj) , hfx_err(jpi,jpj) ,     & 
+         &      hfx_res(jpi,jpj) , hfx_snw(jpi,jpj) , hfx_sub(jpi,jpj) ,     & 
          &      hfx_in (jpi,jpj) , hfx_out(jpi,jpj) , fhld   (jpi,jpj) ,                        &
          &      hfx_sum(jpi,jpj) , hfx_bom(jpi,jpj) , hfx_bog(jpi,jpj) , hfx_dif(jpi,jpj) ,     &
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/ice1D.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/ice1D.F90	(revision 8517)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/ice1D.F90	(revision 8518)
@@ -47,5 +47,4 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   hfx_opw_1d
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   hfx_snw_1d
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   hfx_err_1d
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   hfx_err_rem_1d
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   hfx_err_dif_1d
@@ -178,5 +177,5 @@
          &      rn_amax_1d(jpij) ,                                         &
          &      hfx_thd_1d(jpij) , hfx_spr_1d(jpij) ,                      &
-         &      hfx_snw_1d(jpij) , hfx_sub_1d(jpij) , hfx_err_1d(jpij) ,   &
+         &      hfx_snw_1d(jpij) , hfx_sub_1d(jpij) ,                      &
          &      hfx_res_1d(jpij) , hfx_err_rem_1d(jpij) , hfx_err_dif_1d(jpij) , hfx_out_1d(jpij), STAT=ierr(ii) )
       !
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceadv.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceadv.F90	(revision 8517)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceadv.F90	(revision 8518)
@@ -41,5 +41,10 @@
    INTEGER, PARAMETER ::   np_advPRA = 1   ! Prather scheme
    INTEGER, PARAMETER ::   np_advUMx = 2   ! Ultimate-Macho scheme
-
+   !
+   ! ** namelist (namice_adv) **
+   LOGICAL ::   ln_adv_Pra   ! Prather        advection scheme
+   LOGICAL ::   ln_adv_UMx   ! Ultimate-Macho advection scheme
+   INTEGER ::   nn_UMx       ! order of the UMx advection scheme   
+   !
    !! * Substitution
 #  include "vectopt_loop_substitute.h90"
@@ -85,5 +90,5 @@
       CASE( np_advUMx )                ! ULTIMATE-MACHO scheme !
          !                             !-----------------------!
-         CALL ice_adv_umx( kt, u_ice, v_ice,  &
+         CALL ice_adv_umx( nn_UMx, kt, u_ice, v_ice,  &
             &              ato_i, v_i, v_s, smv_i, oa_i, a_i, a_ip, v_ip, e_s, e_i )
       !                                !-----------------------!
@@ -107,4 +112,8 @@
       IF( iom_use('deitrp') )   CALL iom_put( "deitrp" , diag_trp_ei         )         ! advected ice enthalpy (W/m2)
       IF( iom_use('destrp') )   CALL iom_put( "destrp" , diag_trp_es         )         ! advected snw enthalpy (W/m2)
+
+      IF( lrst_ice ) THEN                       !* write Prather fields in the restart file
+         IF( ln_adv_Pra )   CALL adv_pra_rst( 'WRITE', kt )
+      ENDIF
                
       ! controls
@@ -158,4 +167,6 @@
       IF( ioptio /= 1 )   CALL ctl_stop( 'ice_adv_init: choose one and only one ice advection scheme (ln_adv_Pra or ln_adv_UMx)' )
       !
+      IF( ln_adv_Pra )   CALL adv_pra_rst( 'READ' )  !* read or initialize all required files
+      !
    END SUBROUTINE ice_adv_init
 
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceadv_prather.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceadv_prather.F90	(revision 8517)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceadv_prather.F90	(revision 8518)
@@ -20,4 +20,5 @@
    USE lbclnk         ! lateral boundary condition - MPP exchanges
    USE in_out_manager ! I/O manager
+   USE iom            ! I/O library
    USE prtctl         ! Print control
    USE lib_mpp        ! MPP library
@@ -28,4 +29,5 @@
 
    PUBLIC   ice_adv_prather   ! called by iceadv
+   PUBLIC   adv_pra_rst       ! called by iceadv
 
    !! * Substitutions
@@ -592,4 +594,405 @@
    END SUBROUTINE adv_y
 
+   SUBROUTINE adv_pra_rst( cdrw, kt )
+      !!---------------------------------------------------------------------
+      !!                   ***  ROUTINE adv_pra_rst  ***
+      !!                     
+      !! ** Purpose :   Read or write RHG file in restart file
+      !!
+      !! ** Method  :   use of IOM library
+      !!----------------------------------------------------------------------
+      CHARACTER(len=*) , INTENT(in) ::   cdrw   ! "READ"/"WRITE" flag
+      INTEGER, OPTIONAL, INTENT(in) ::   kt     ! ice time-step
+      !
+      INTEGER ::   jk, jl   ! dummy loop indices
+      INTEGER ::   iter     ! local integer
+      INTEGER ::   id1      ! local integer
+      CHARACTER(len=25) ::   znam
+      CHARACTER(len=2)  ::   zchar, zchar1
+      REAL(wp), DIMENSION(jpi,jpj) :: z2d
+      !!----------------------------------------------------------------------
+      !
+      IF( TRIM(cdrw) == 'READ' ) THEN        ! Read/initialize
+         !                                   ! ---------------
+         IF( ln_rstart ) THEN                   !* Read the restart file
+            !
+            id1 = iom_varid( numrir, 'sxopw' , ldstop = .FALSE. )
+            !
+            IF( id1 > 0 ) THEN      ! fields exist
+               DO jl = 1, jpl 
+                  WRITE(zchar,'(I2.2)') jl
+                  znam = 'sxice'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sxice(:,:,jl) = z2d(:,:)
+                  znam = 'syice'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  syice(:,:,jl) = z2d(:,:)
+                  znam = 'sxxice'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sxxice(:,:,jl) = z2d(:,:)
+                  znam = 'syyice'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  syyice(:,:,jl) = z2d(:,:)
+                  znam = 'sxyice'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sxyice(:,:,jl) = z2d(:,:)
+                  znam = 'sxsn'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sxsn(:,:,jl) = z2d(:,:)
+                  znam = 'sysn'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sysn(:,:,jl) = z2d(:,:)
+                  znam = 'sxxsn'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sxxsn(:,:,jl) = z2d(:,:)
+                  znam = 'syysn'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  syysn(:,:,jl) = z2d(:,:)
+                  znam = 'sxysn'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sxysn(:,:,jl) = z2d(:,:)
+                  znam = 'sxa'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sxa(:,:,jl) = z2d(:,:)
+                  znam = 'sya'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sya(:,:,jl) = z2d(:,:)
+                  znam = 'sxxa'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sxxa(:,:,jl) = z2d(:,:)
+                  znam = 'syya'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  syya(:,:,jl) = z2d(:,:)
+                  znam = 'sxya'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sxya(:,:,jl) = z2d(:,:)
+                  znam = 'sxc0'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sxc0(:,:,jl) = z2d(:,:)
+                  znam = 'syc0'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  syc0(:,:,jl) = z2d(:,:)
+                  znam = 'sxxc0'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sxxc0(:,:,jl) = z2d(:,:)
+                  znam = 'syyc0'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  syyc0(:,:,jl) = z2d(:,:)
+                  znam = 'sxyc0'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sxyc0(:,:,jl) = z2d(:,:)
+                  znam = 'sxsal'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sxsal(:,:,jl) = z2d(:,:)
+                  znam = 'sysal'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sysal(:,:,jl) = z2d(:,:)
+                  znam = 'sxxsal'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sxxsal(:,:,jl) = z2d(:,:)
+                  znam = 'syysal'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  syysal(:,:,jl) = z2d(:,:)
+                  znam = 'sxysal'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sxysal(:,:,jl) = z2d(:,:)
+                  znam = 'sxage'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sxage(:,:,jl) = z2d(:,:)
+                  znam = 'syage'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  syage(:,:,jl) = z2d(:,:)
+                  znam = 'sxxage'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sxxage(:,:,jl) = z2d(:,:)
+                  znam = 'syyage'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  syyage(:,:,jl) = z2d(:,:)
+                  znam = 'sxyage'//'_htc'//zchar
+                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                  sxyage(:,:,jl)= z2d(:,:)
+               END DO
+               ! MV MP 2016
+               IF ( nn_pnd_scheme > 0 ) THEN
+                  DO jl = 1, jpl 
+                     WRITE(zchar,'(I2.2)') jl
+                     znam = 'sxap'//'_htc'//zchar
+                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                     sxap(:,:,jl) = z2d(:,:)
+                     znam = 'syap'//'_htc'//zchar
+                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                     syap(:,:,jl) = z2d(:,:)
+                     znam = 'sxxap'//'_htc'//zchar
+                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                     sxxap(:,:,jl) = z2d(:,:)
+                     znam = 'syyap'//'_htc'//zchar
+                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                     syyap(:,:,jl) = z2d(:,:)
+                     znam = 'sxyap'//'_htc'//zchar
+                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                     sxyap(:,:,jl) = z2d(:,:)
+
+                     znam = 'sxvp'//'_htc'//zchar
+                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                     sxvp(:,:,jl) = z2d(:,:)
+                     znam = 'syvp'//'_htc'//zchar
+                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                     syvp(:,:,jl) = z2d(:,:)
+                     znam = 'sxxvp'//'_htc'//zchar
+                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                     sxxvp(:,:,jl) = z2d(:,:)
+                     znam = 'syyvp'//'_htc'//zchar
+                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                     syyvp(:,:,jl) = z2d(:,:)
+                     znam = 'sxyvp'//'_htc'//zchar
+                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                     sxyvp(:,:,jl) = z2d(:,:)
+                  END DO
+               ENDIF
+               ! END MV MP 2016
+
+               CALL iom_get( numrir, jpdom_autoglo, 'sxopw ' ,  sxopw  )
+               CALL iom_get( numrir, jpdom_autoglo, 'syopw ' ,  syopw  )
+               CALL iom_get( numrir, jpdom_autoglo, 'sxxopw' ,  sxxopw )
+               CALL iom_get( numrir, jpdom_autoglo, 'syyopw' ,  syyopw )
+               CALL iom_get( numrir, jpdom_autoglo, 'sxyopw' ,  sxyopw )
+
+               DO jl = 1, jpl 
+                  WRITE(zchar,'(I2.2)') jl
+                  DO jk = 1, nlay_i 
+                     WRITE(zchar1,'(I2.2)') jk
+                     znam = 'sxe'//'_il'//zchar1//'_htc'//zchar
+                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                     sxe(:,:,jk,jl) = z2d(:,:)
+                     znam = 'sye'//'_il'//zchar1//'_htc'//zchar
+                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                     sye(:,:,jk,jl) = z2d(:,:)
+                     znam = 'sxxe'//'_il'//zchar1//'_htc'//zchar
+                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                     sxxe(:,:,jk,jl) = z2d(:,:)
+                     znam = 'syye'//'_il'//zchar1//'_htc'//zchar
+                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                     syye(:,:,jk,jl) = z2d(:,:)
+                     znam = 'sxye'//'_il'//zchar1//'_htc'//zchar
+                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
+                     sxye(:,:,jk,jl) = z2d(:,:)
+                  END DO
+               END DO
+               !
+            ELSE                                     ! start rheology from rest
+               IF(lwp) WRITE(numout,*) '   ==>>   previous run without Prather, set moments to 0'
+               sxopw (:,:) = 0._wp   ;   sxice (:,:,:) = 0._wp   ;   sxsn (:,:,:)  = 0._wp   ;   sxa  (:,:,:) = 0._wp
+               syopw (:,:) = 0._wp   ;   syice (:,:,:) = 0._wp   ;   sysn (:,:,:)  = 0._wp   ;   sya  (:,:,:) = 0._wp
+               sxxopw(:,:) = 0._wp   ;   sxxice(:,:,:) = 0._wp   ;   sxxsn(:,:,:)  = 0._wp   ;   sxxa (:,:,:) = 0._wp
+               syyopw(:,:) = 0._wp   ;   syyice(:,:,:) = 0._wp   ;   syysn(:,:,:)  = 0._wp   ;   syya (:,:,:) = 0._wp
+               sxyopw(:,:) = 0._wp   ;   sxyice(:,:,:) = 0._wp   ;   sxysn(:,:,:)  = 0._wp   ;   sxya (:,:,:) = 0._wp
+               !
+               sxc0  (:,:,:) = 0._wp   ;   sxe  (:,:,:,:) = 0._wp   ;   sxsal  (:,:,:) = 0._wp   ;   sxage  (:,:,:) = 0._wp
+               syc0  (:,:,:) = 0._wp   ;   sye  (:,:,:,:) = 0._wp   ;   sysal  (:,:,:) = 0._wp   ;   syage  (:,:,:) = 0._wp
+               sxxc0 (:,:,:) = 0._wp   ;   sxxe (:,:,:,:) = 0._wp   ;   sxxsal (:,:,:) = 0._wp   ;   sxxage (:,:,:) = 0._wp
+               syyc0 (:,:,:) = 0._wp   ;   syye (:,:,:,:) = 0._wp   ;   syysal (:,:,:) = 0._wp   ;   syyage (:,:,:) = 0._wp
+               sxyc0 (:,:,:) = 0._wp   ;   sxye (:,:,:,:) = 0._wp   ;   sxysal (:,:,:) = 0._wp   ;   sxyage (:,:,:) = 0._wp
+               ! MV MP 2016
+               IF ( nn_pnd_scheme > 0 ) THEN
+                  sxap  (:,:,:) = 0._wp    ; sxvp  (:,:,:) = 0._wp 
+                  syap  (:,:,:) = 0._wp    ; syvp  (:,:,:) = 0._wp 
+                  sxxap (:,:,:) = 0._wp    ; sxxvp (:,:,:) = 0._wp 
+                  syyap (:,:,:) = 0._wp    ; syyvp (:,:,:) = 0._wp 
+                  sxyap (:,:,:) = 0._wp    ; sxyvp (:,:,:) = 0._wp
+               ENDIF
+               ! END MV MP 2016
+            ENDIF
+         ELSE                                   !* Start from rest
+            IF(lwp) WRITE(numout,*) '   ==>>   start from rest: set moments to 0'
+            sxopw (:,:) = 0._wp   ;   sxice (:,:,:) = 0._wp   ;   sxsn (:,:,:)  = 0._wp   ;   sxa  (:,:,:) = 0._wp
+            syopw (:,:) = 0._wp   ;   syice (:,:,:) = 0._wp   ;   sysn (:,:,:)  = 0._wp   ;   sya  (:,:,:) = 0._wp
+            sxxopw(:,:) = 0._wp   ;   sxxice(:,:,:) = 0._wp   ;   sxxsn(:,:,:)  = 0._wp   ;   sxxa (:,:,:) = 0._wp
+            syyopw(:,:) = 0._wp   ;   syyice(:,:,:) = 0._wp   ;   syysn(:,:,:)  = 0._wp   ;   syya (:,:,:) = 0._wp
+            sxyopw(:,:) = 0._wp   ;   sxyice(:,:,:) = 0._wp   ;   sxysn(:,:,:)  = 0._wp   ;   sxya (:,:,:) = 0._wp
+            !
+            sxc0  (:,:,:) = 0._wp   ;   sxe  (:,:,:,:) = 0._wp   ;   sxsal  (:,:,:) = 0._wp   ;   sxage  (:,:,:) = 0._wp
+            syc0  (:,:,:) = 0._wp   ;   sye  (:,:,:,:) = 0._wp   ;   sysal  (:,:,:) = 0._wp   ;   syage  (:,:,:) = 0._wp
+            sxxc0 (:,:,:) = 0._wp   ;   sxxe (:,:,:,:) = 0._wp   ;   sxxsal (:,:,:) = 0._wp   ;   sxxage (:,:,:) = 0._wp
+            syyc0 (:,:,:) = 0._wp   ;   syye (:,:,:,:) = 0._wp   ;   syysal (:,:,:) = 0._wp   ;   syyage (:,:,:) = 0._wp
+            sxyc0 (:,:,:) = 0._wp   ;   sxye (:,:,:,:) = 0._wp   ;   sxysal (:,:,:) = 0._wp   ;   sxyage (:,:,:) = 0._wp
+            ! MV MP 2016
+            IF ( nn_pnd_scheme > 0 ) THEN
+               sxap  (:,:,:) = 0._wp    ; sxvp  (:,:,:) = 0._wp 
+               syap  (:,:,:) = 0._wp    ; syvp  (:,:,:) = 0._wp 
+               sxxap (:,:,:) = 0._wp    ; sxxvp (:,:,:) = 0._wp 
+               syyap (:,:,:) = 0._wp    ; syyvp (:,:,:) = 0._wp 
+               sxyap (:,:,:) = 0._wp    ; sxyvp (:,:,:) = 0._wp
+            ENDIF
+            ! END MV MP 2016
+         ENDIF
+         !
+      ELSEIF( TRIM(cdrw) == 'WRITE' ) THEN   ! Create restart file
+         !                                   ! -------------------
+         IF(lwp) WRITE(numout,*) '---- adv-rst ----'
+         iter = kt + nn_fsbc - 1             ! ice restarts are written at kt == nitrst - nn_fsbc + 1
+         !
+         DO jl = 1, jpl 
+            WRITE(zchar,'(I2.2)') jl
+            znam = 'sxice'//'_htc'//zchar
+            z2d(:,:) = sxice(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'syice'//'_htc'//zchar
+            z2d(:,:) = syice(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'sxxice'//'_htc'//zchar
+            z2d(:,:) = sxxice(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'syyice'//'_htc'//zchar
+            z2d(:,:) = syyice(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'sxyice'//'_htc'//zchar
+            z2d(:,:) = sxyice(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'sxsn'//'_htc'//zchar
+            z2d(:,:) = sxsn(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'sysn'//'_htc'//zchar
+            z2d(:,:) = sysn(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'sxxsn'//'_htc'//zchar
+            z2d(:,:) = sxxsn(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'syysn'//'_htc'//zchar
+            z2d(:,:) = syysn(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'sxysn'//'_htc'//zchar
+            z2d(:,:) = sxysn(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'sxa'//'_htc'//zchar
+            z2d(:,:) = sxa(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'sya'//'_htc'//zchar
+            z2d(:,:) = sya(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'sxxa'//'_htc'//zchar
+            z2d(:,:) = sxxa(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'syya'//'_htc'//zchar
+            z2d(:,:) = syya(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'sxya'//'_htc'//zchar
+            z2d(:,:) = sxya(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'sxc0'//'_htc'//zchar
+            z2d(:,:) = sxc0(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'syc0'//'_htc'//zchar
+            z2d(:,:) = syc0(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'sxxc0'//'_htc'//zchar
+            z2d(:,:) = sxxc0(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'syyc0'//'_htc'//zchar
+            z2d(:,:) = syyc0(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'sxyc0'//'_htc'//zchar
+            z2d(:,:) = sxyc0(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'sxsal'//'_htc'//zchar
+            z2d(:,:) = sxsal(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'sysal'//'_htc'//zchar
+            z2d(:,:) = sysal(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'sxxsal'//'_htc'//zchar
+            z2d(:,:) = sxxsal(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'syysal'//'_htc'//zchar
+            z2d(:,:) = syysal(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'sxysal'//'_htc'//zchar
+            z2d(:,:) = sxysal(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'sxage'//'_htc'//zchar
+            z2d(:,:) = sxage(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'syage'//'_htc'//zchar
+            z2d(:,:) = syage(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'sxxage'//'_htc'//zchar
+            z2d(:,:) = sxxage(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'syyage'//'_htc'//zchar
+            z2d(:,:) = syyage(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            znam = 'sxyage'//'_htc'//zchar
+            z2d(:,:) = sxyage(:,:,jl)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+         END DO
+
+         CALL iom_rstput( iter, nitrst, numriw, 'sxopw ' ,  sxopw  )
+         CALL iom_rstput( iter, nitrst, numriw, 'syopw ' ,  syopw  )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxxopw' ,  sxxopw )
+         CALL iom_rstput( iter, nitrst, numriw, 'syyopw' ,  syyopw )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxyopw' ,  sxyopw )
+         
+         DO jl = 1, jpl 
+            WRITE(zchar,'(I2.2)') jl
+            DO jk = 1, nlay_i 
+               WRITE(zchar1,'(I2.2)') jk
+               znam = 'sxe'//'_il'//zchar1//'_htc'//zchar
+               z2d(:,:) = sxe(:,:,jk,jl)
+               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+               znam = 'sye'//'_il'//zchar1//'_htc'//zchar
+               z2d(:,:) = sye(:,:,jk,jl)
+               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+               znam = 'sxxe'//'_il'//zchar1//'_htc'//zchar
+               z2d(:,:) = sxxe(:,:,jk,jl)
+               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+               znam = 'syye'//'_il'//zchar1//'_htc'//zchar
+               z2d(:,:) = syye(:,:,jk,jl)
+               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+               znam = 'sxye'//'_il'//zchar1//'_htc'//zchar
+               z2d(:,:) = sxye(:,:,jk,jl)
+               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            END DO
+         END DO
+         ! MV MP 2016
+         IF ( nn_pnd_scheme > 0 ) THEN
+            DO jl = 1, jpl 
+               WRITE(zchar,'(I2.2)') jl
+               znam = 'sxap'//'_htc'//zchar
+               z2d(:,:) = sxap(:,:,jl)
+               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+               znam = 'syap'//'_htc'//zchar
+               z2d(:,:) = syap(:,:,jl)
+               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+               znam = 'sxxap'//'_htc'//zchar
+               z2d(:,:) = sxxap(:,:,jl)
+               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+               znam = 'syyap'//'_htc'//zchar
+               z2d(:,:) = syyap(:,:,jl)
+               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+               znam = 'sxyap'//'_htc'//zchar
+               z2d(:,:) = sxyap(:,:,jl)
+               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+   
+               znam = 'sxvp'//'_htc'//zchar
+               z2d(:,:) = sxvp(:,:,jl)
+               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+               znam = 'syvp'//'_htc'//zchar
+               z2d(:,:) = syvp(:,:,jl)
+               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+               znam = 'sxxvp'//'_htc'//zchar
+               z2d(:,:) = sxxvp(:,:,jl)
+               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+               znam = 'syyvp'//'_htc'//zchar
+               z2d(:,:) = syyvp(:,:,jl)
+               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+               znam = 'sxyvp'//'_htc'//zchar
+               z2d(:,:) = sxyvp(:,:,jl)
+               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
+            END DO
+         ENDIF
+         !
+      ENDIF
+      !
+   END SUBROUTINE adv_pra_rst
+
 #else
    !!----------------------------------------------------------------------
